OpenTTD

- Main Page
- Related Pages
- Modules
- Namespaces
- Data Structures
- Files

- Data Structures
- Class Hierarchy
- Data Fields

Public Member Functions | Private Attributes
NWidgetSmallmapDisplay Class Reference

Custom container class for displaying smallmap with a vertically resizing legend panel. More...

Inheritance diagram for NWidgetSmallmapDisplay:

## Public Member Functions
virtual void | SetupSmallestSize (Window *w, bool init_array)
| Compute smallest size needed by the widget.
virtual void | AssignSizePosition (SizingType sizing, uint x, uint y, uint given_width, uint given_height, bool rtl)
| Assign size and position to the widget.
virtual NWidgetCore * | GetWidgetFromPos (int x, int y)
| Retrieve a widget by its position.
virtual void | Draw (const Window *w)
| Draw the widgets of the tree.
Public Member Functions inherited from NWidgetContainer
| NWidgetContainer (WidgetType tp)
| Constructor container baseclass.
void | Add (NWidgetBase *wid)
| Append widget wid to container.
void | FillNestedArray (NWidgetBase **array, uint length)
bool | IsEmpty ()
| Return whether the container is empty.
NWidgetBase * | GetWidgetOfType (WidgetType tp)
| Retrieve a widget by its type.
Public Member Functions inherited from NWidgetBase
| NWidgetBase (WidgetType tp)
| Base class constructor.
virtual bool | IsHighlighted () const
virtual TextColour | GetHighlightColour () const
virtual void | SetHighlighted (TextColour highlight_colour)
void | SetPadding (uint8 top, uint8 right, uint8 bottom, uint8 left)
| Set additional space (padding) around the widget.
uint | GetHorizontalStepSize (SizingType sizing) const
| Get the horizontal sizing step.
uint | GetVerticalStepSize (SizingType sizing) const
| Get the vertical sizing step.
virtual void | SetDirty (const Window *w) const
| Mark the widget as 'dirty' (in need of repaint).
Public Member Functions inherited from ZeroedMemoryAllocator
void * | operator new (size_t size)
| Memory allocator for a single class instance.
void * | operator new[] (size_t size)
| Memory allocator for an array of class instances.
void | operator delete (void *ptr)
| Memory release for a single class instance.
void | operator delete[] (void *ptr)
| Memory release for an array of class instances.

## Private Attributes
const SmallMapWindow * | smallmap_window
| Window manager instance.

## Additional Inherited Members
Data Fields inherited from NWidgetBase
WidgetType | type
| Type of the widget / nested widget.
uint | fill_x
| Horizontal fill stepsize (from initial size, `0` means not resizable).
uint | fill_y
| Vertical fill stepsize (from initial size, `0` means not resizable).
uint | resize_x
| Horizontal resize step (`0` means not resizable).
uint | resize_y
| Vertical resize step (`0` means not resizable).
uint | smallest_x
| Smallest horizontal size of the widget in a filled window.
uint | smallest_y
| Smallest vertical size of the widget in a filled window.
uint | current_x
| Current horizontal size (after resizing).
uint | current_y
| Current vertical size (after resizing).
uint | pos_x
| Horizontal position of top-left corner of the widget in the window.
uint | pos_y
| Vertical position of top-left corner of the widget in the window.
NWidgetBase * | next
| Pointer to next widget in container. Managed by parent container widget.
NWidgetBase * | prev
| Pointer to previous widget in container. Managed by parent container widget.
uint8 | padding_top
| Paddings added to the top of the widget. Managed by parent container widget.
uint8 | padding_right
| Paddings added to the right of the widget. Managed by parent container widget. (parent container may swap this with padding_left for RTL)
uint8 | padding_bottom
| Paddings added to the bottom of the widget. Managed by parent container widget.
uint8 | padding_left
| Paddings added to the left of the widget. Managed by parent container widget. (parent container may swap this with padding_right for RTL)
Protected Member Functions inherited from NWidgetBase
void | StoreSizePosition (SizingType sizing, uint x, uint y, uint given_width, uint given_height)
| Store size and position.
Protected Attributes inherited from NWidgetContainer
NWidgetBase * | head
| Pointer to first widget in container.
NWidgetBase * | tail
| Pointer to last widget in container.

## Detailed Description

Custom container class for displaying smallmap with a vertically resizing legend panel.

The legend panel has a smallest height that depends on its width. Standard containers cannot handle this case.

Note
  The container assumes it has two children, the first is the display, the second is the bar with legends and selection image buttons. Both children should be both horizontally and vertically resizable and horizontally fillable. The bar should have a minimal size with a zero-size legends display. Child padding is not supported.

Definition at line 1687 of file smallmap_gui.cpp.

## Member Function Documentation

virtual void NWidgetSmallmapDisplay::AssignSizePosition | ( | SizingType | sizing,
|  | uint | x,
|  | uint | y,
|  | uint | given_width,
|  | uint | given_height,
|  | bool | rtl
| ) |  |
| inline virtual

Assign size and position to the widget.

Parameters

  sizing | Type of resizing to perform.
  x | Horizontal offset of the widget relative to the left edge of the window.
  y | Vertical offset of the widget relative to the top edge of the window.
  given_width | Width allocated to the widget.
  given_height | Height allocated to the widget.
  rtl | Adapt for right-to-left languages (position contents of horizontal containers backwards).

Afterwards, pos_x and pos_y contain the top-left position of the widget, smallest_x and smallest_y contain the smallest size such that all widgets of the window are consistent, and current_x and current_y contain the current size.

Implements NWidgetBase.

Definition at line 1713 of file smallmap_gui.cpp.

References NWidgetBase::AssignSizePosition(), NWidgetBase::current_x, NWidgetBase::current_y, NWidgetContainer::head, max(), NWidgetBase::next, NWidgetBase::pos_x, NWidgetBase::pos_y, NWidgetBase::smallest_x, NWidgetBase::smallest_y, ST_RESIZE, and ST_SMALLEST.

virtual void NWidgetSmallmapDisplay::Draw | ( | const Window * | w | ) |
| inline virtual

Draw the widgets of the tree.

The function calls Window::DrawWidget for each widget with a non-negative index, after the widget itself is painted.

Parameters

  w | Window that owns the tree.

Implements NWidgetBase.

Definition at line 1747 of file smallmap_gui.cpp.

References NWidgetContainer::head, and NWidgetBase::next.

virtual NWidgetCore* NWidgetSmallmapDisplay::GetWidgetFromPos | ( | int | x,
|  | int | y
| ) |  |
| inline virtual

Retrieve a widget by its position.

Parameters

  x | Horizontal position relative to the left edge of the window.
  y | Vertical position relative to the top edge of the window.

Returns
  Returns the deepest nested widget that covers the given position, or `NULL` if no widget can be found.

Implements NWidgetBase.

Definition at line 1737 of file smallmap_gui.cpp.

References NWidgetBase::current_x, NWidgetBase::current_y, NWidgetCore::GetWidgetFromPos(), NWidgetContainer::head, IsInsideBS(), NWidgetBase::next, NWidgetBase::pos_x, and NWidgetBase::pos_y.

virtual void NWidgetSmallmapDisplay::SetupSmallestSize | ( | Window * | w,
|  | bool | init_array
| ) |  |
| inline virtual

Compute smallest size needed by the widget.

The smallest size of a widget is the smallest size that a widget needs to display itself properly. In addition, filling and resizing of the widget are computed. The function calls Window::UpdateWidgetSize for each leaf widget and background widget without child with a non-negative index.

Parameters

  w | Window owning the widget.
  init_array | Initialize the `w->nested_array`.

Note
  After the computation, the results can be queried by accessing the smallest_x and smallest_y data members of the widget.

Implements NWidgetBase.

Definition at line 1695 of file smallmap_gui.cpp.

References NWidgetBase::fill_x, NWidgetBase::fill_y, SmallMapWindow::GetLegendHeight(), SmallMapWindow::GetMinLegendWidth(), NWidgetContainer::head, max(), min(), SmallMapWindow::min_number_of_columns, NWidgetBase::next, NWidgetBase::resize_x, NWidgetBase::resize_y, NWidgetBase::SetupSmallestSize(), NWidgetBase::smallest_x, NWidgetBase::smallest_y, and smallmap_window.

The documentation for this class was generated from the following file:

- src/smallmap_gui.cpp